-- ZB_DM_WJPK_HB ZB_DM_未决赔款合并


-- step1：
-- 团队汇总
CREATE TEMPORARY VIEW VIEW_ZB_DM_WJPK_HB_TUANDUI AS
SELECT
      s1.`setdate`                          as `setdate`
     ,s1.`chnl`                             as `chnl`
     ,s1.`classcode`                        as `classcode`
     ,s1.`LEVEL1COMCODE`                    as `LEVEL1COMCODE`
     ,s1.`LEVEL2COMCODE`                    as `LEVEL2COMCODE`
     ,s1.`LEVEL3COMCODE`                    as `LEVEL3COMCODE`
     ,s1.`LEVEL4COMCODE`                    as `LEVEL4COMCODE`
     ,sum(cast(s1.`settledamount` as DECIMAL(18,2))) as `cost`
from (
         select
             *
         from ZB_ODS.ZB_ODS_KAFKA.LPDATA
         where
             `COMNAME` is not null
           and LEFT(`setdate`,8) = DATE_FORMAT(LOCALTIMESTAMP,'yyyyMMdd')
     ) s1
where s1.`flag`= 'wj'
group by
    s1.`setdate`
    ,s1.`classcode`
    ,s1.`chnl`
    ,s1.`LEVEL1COMCODE`
    ,s1.`LEVEL2COMCODE`
    ,s1.`LEVEL3COMCODE`
    ,s1.`LEVEL4COMCODE`
;


-- ZB_DM_WJPK ZB_DM_未决赔款
-- key:allwjpk/日期
-- 1、日期:未决估损调整日期(yyyyMMdd)

-- 总公司 
insert into ZB_DM.ZB_DM_REDIS.SET_DECIMAL
select
    CONCAT(
            'allwjpk/'
        ,s1.`setdate`
        )                                      as `key`
     ,sum(cast(s1.`cost` as DECIMAL(18,2))) as `val`
from VIEW_ZB_DM_WJPK_HB_TUANDUI s1
group by
    s1.`setdate`
;

-- 分公司
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'provwjpk/'
        ,s1.`setdate`
        )                                      as `key`
     ,s1.`LEVEL1COMCODE`                    as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2))) as `val`
from VIEW_ZB_DM_WJPK_HB_TUANDUI s1
group by
    s1.`setdate`
       ,s1.`LEVEL1COMCODE`
;

-- 中支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'citywjpk/'
        ,s1.`setdate`
        )                                      as `key`
     ,s1.`LEVEL2COMCODE`                    as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2))) as `val`
from VIEW_ZB_DM_WJPK_HB_TUANDUI s1
group by
    s1.`setdate`
       ,s1.`LEVEL2COMCODE`
;


-- 县支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'countywjpk/'
        ,s1.`setdate`
        )                                      as `key`
     ,s1.`LEVEL3COMCODE`                    as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2))) as `val`
from VIEW_ZB_DM_WJPK_HB_TUANDUI s1
group by
    s1.`setdate`
    ,s1.`LEVEL3COMCODE`
;


-- 团队
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'teamwjpk/'
        ,s1.`setdate`
        )                                      as `key`
     ,s1.`LEVEL4COMCODE`                    as `hkey`
     ,cast(s1.`cost` as DECIMAL(18,2))      as `val`
from VIEW_ZB_DM_WJPK_HB_TUANDUI s1
;


-- ZB_DM_FXLWJPK ZB_DM_分险类未决赔款
-- allwjxlbf/日期	险类代码
-- 1、日期:已决立案日期  未决估损调整日期(yyyyMMdd)


--总公司
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'allwjxlbf/'
        ,s1.`setdate`
        )                                       as `key`
     ,s1.`classcode`                         as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))  as `val`
from VIEW_ZB_DM_WJPK_HB_TUANDUI s1
where s1.`classcode` is not null
group by
    s1.`setdate`
    ,s1.`classcode`

;

-- 分公司
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'provwjxlbf/'
        ,s1.`setdate`
        ,'/',s1.`LEVEL1COMCODE`
        )                                       as `key`
     ,s1.`classcode`                         as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))  as `val`
from VIEW_ZB_DM_WJPK_HB_TUANDUI s1
where s1.`classcode` is not null
group by
    s1.`setdate`
    ,s1.`classcode`
    ,s1.`LEVEL1COMCODE`
;

-- 中支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'citywjxlbf/'
        ,s1.`setdate`
        ,'/',s1.`LEVEL2COMCODE`
        )                                    as `key`
     ,s1.`classcode`                         as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))  as `val`
from VIEW_ZB_DM_WJPK_HB_TUANDUI s1
where s1.`classcode` is not null
group by
    s1.`setdate`
    ,s1.`classcode`
    ,s1.`LEVEL2COMCODE`
;

-- 县支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'countywjxlbf/'
        ,s1.`setdate`
        ,'/',s1.`LEVEL3COMCODE`
        )                                    as `key`
     ,s1.`classcode`                         as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))  as `val`
from VIEW_ZB_DM_WJPK_HB_TUANDUI s1
where s1.`classcode` is not null
group by
    s1.`setdate`
    ,s1.`classcode`
    ,s1.`LEVEL3COMCODE`
;

-- 团队
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'teamwjxlbf/'
        ,s1.`setdate`
        ,'/',s1.`LEVEL4COMCODE`
        )                               as `key`
     ,s1.`classcode`                    as `hkey`
     ,cast(s1.`cost` as DECIMAL(18,2))  as `val`
from VIEW_ZB_DM_WJPK_HB_TUANDUI s1
where s1.`classcode` is not null
;



-- ZB_DM_FQDWJPK ZB_DM_分渠道未决赔款
-- chnlwjbf/日期	渠道代码
-- 1、日期:已决立案日期  未决估损调整日期(yyyyMMdd)


--总公司
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'chnlwjbf/'
        ,s1.`setdate`
        ,'/00000000'
        )                                       as `key`
     ,s1.`chnl`                              as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))  as `val`
from VIEW_ZB_DM_WJPK_HB_TUANDUI s1
where s1.`chnl` is not null
group by
    s1.`setdate`
    ,s1.`chnl`

;

-- 分公司
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'chnlwjbf/'
        ,s1.`setdate`
        ,'/',s1.`LEVEL1COMCODE`
        )                                       as `key`
     ,s1.`chnl`                              as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))  as `val`
from VIEW_ZB_DM_WJPK_HB_TUANDUI s1
where s1.`chnl` is not null
group by
    s1.`setdate`
   ,s1.`chnl`
   ,s1.`LEVEL1COMCODE`
;

-- 中支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'citychnlwjbf/'
        ,s1.`setdate`
        ,'/',s1.`LEVEL2COMCODE`
        )                                    as `key`
     ,s1.`chnl`                              as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))  as `val`
from VIEW_ZB_DM_WJPK_HB_TUANDUI s1
where s1.`chnl` is not null
group by
    s1.`setdate`
   ,s1.`chnl`
   ,s1.`LEVEL2COMCODE`
;

-- 县支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'countychnlwjbf/'
        ,s1.`setdate`
        ,'/',s1.`LEVEL3COMCODE`
        )                                    as `key`
     ,s1.`chnl`                              as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))  as `val`
from VIEW_ZB_DM_WJPK_HB_TUANDUI s1
where s1.`chnl` is not null
group by
    s1.`setdate`
    ,s1.`chnl`
    ,s1.`LEVEL3COMCODE`
;

-- 团队
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'teamchnlwjbf/'
        ,s1.`setdate`
        ,'/',s1.`LEVEL4COMCODE`
        )                               as `key`
     ,s1.`chnl`                         as `hkey`
     ,cast(s1.`cost` as DECIMAL(18,2))  as `val`
from VIEW_ZB_DM_WJPK_HB_TUANDUI s1
where s1.`chnl` is not null
;